import java.util.*;
import java.math.*;
import java.io.*;
import java.text.*;


public class Cockchaf {
    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static String line, newline;
    
    static long N, T;
    static double S;
    
    static StringTokenizer st;
    static ArrayList<Point> points = new ArrayList<Point>();
    
    static ArrayList<double[]> nodes = new ArrayList<double[]>();
    static ArrayList<double[]> newnodes = new ArrayList<double[]>();
    static ArrayList<double[]> temp = new ArrayList<double[]>();
    
    static HashMap<double[],ArrayList<double[]>> outnodesMap = new HashMap<double[], ArrayList<double[]>>();
    static HashMap<double[],Boolean> visited = new HashMap<double[], Boolean>();
    static HashMap<double[],Double> price = new HashMap<double[], Double>();
    static HashMap<double[],Double> reachprice = new HashMap<double[], Double>();
    
    static double x0,xt,y0,yt,z0,zt,x1,y1,z1,x2,y2,z2;
    
    static double[] point1 = new double[3];
    static double[] point2 = new double[3];
    static double[] tmp = new double[3];
    static double[] tmp6 = new double[6];
    
    static double minPath;
    static boolean foundEnd=false;
    
    static double getPrice(double[] p1, double xi, double yi, double zi){
        return 2*Math.sqrt( (xi-p1[0])*(xi-p1[0]) + (yi-p1[1])*(yi-p1[1]) 
                   + (zi-p1[2])*(zi-p1[2])) / S;
    }
    
    static void examineOutnodes(double[] tmp){
        if(outnodesMap.get(tmp)==null){
            System.out.println(" -- outnodes empty");
            return;
        }
        
        temp = outnodesMap.get(tmp);
        for(double[] node : temp){
            System.out.printf(" -- I see outnode %f %f %f%n",node[0],node[1],node[2]);
            if(!visited.get(node)) {
                tmp6 = new double[]{tmp[0],tmp[1],tmp[2],node[0],node[1],node[2]};
                // pricesUGBUG
                if(reachprice.get(node)==null){
                    reachprice.put(node,reachprice.get(tmp)+price.get(tmp6));
                }
                else{
                    if(reachprice.get(tmp)+price.get(tmp6)<reachprice.get(node))
                        reachprice.put(node,reachprice.get(tmp)+price.get(tmp6));
                }
                // marking
                visited.put(node,true);
                newnodes.add(new double[]{node[0],node[1],node[2]});
            }
            
        }
        
    }
    static void findWay(){
        nodes.clear();
        newnodes.clear();
        // end == start
        if(xt==x0 && yt==y0 && zt==z0){
            minPath=0;
            return;
        }

        visited.put(new double[]{x0,y0,z0},true);
        nodes.add(new double[]{x0,y0,z0});
        reachprice.put(new double[]{x0,y0,z0},0.0);
        
        while(!nodes.isEmpty()){
            for(double[] node : nodes){
                System.out.printf("Examining node %f %f %f%n",node[0],node[1],node[2]);
                examineOutnodes(node);
            }
            nodes.clear();
            nodes.addAll(newnodes);
            newnodes.clear();
        }
        
        System.out.println(reachprice.containsKey(new double[]{xt,yt,zt}));
        minPath = reachprice.get(new double[]{xt,yt,zt});

        
    }
    
    static Point searchP(double x, double y, double z){
        Point t;
        for(int i=0;i<points.size();i++){
            t = points.get(i);
            if(x==t.x && y==t.y && z==t.z) return t;
        }
        return null;
    }
    
    public static void main(String[] args) throws Exception {
    /*
        System.out.println(""+getPrice(new double[]{0,0,0},10.0,0.0,0.0));
        return;
    */    
        while( (line=br.readLine()) != null ) {
            st = new StringTokenizer(line);
            N = Long.valueOf(st.nextToken());
            S = (double)Long.valueOf(st.nextToken());
            T = Long.valueOf(st.nextToken());

            nodes.clear();
            newnodes.clear();
            reachprice.clear();
            
            points.clear();


            // reading start, end
            line=br.readLine();
            st = new StringTokenizer(line);
            x0 = Double.valueOf(st.nextToken());
            y0 = Double.valueOf(st.nextToken());
            z0 = Double.valueOf(st.nextToken());
            xt = Double.valueOf(st.nextToken());
            yt = Double.valueOf(st.nextToken());
            zt = Double.valueOf(st.nextToken());
            
            // get edges
            for(int i=0; i<N; i++){
                line=br.readLine();
                st = new StringTokenizer(line);
                x1 = Double.valueOf(st.nextToken());
                y1 = Double.valueOf(st.nextToken());
                z1 = Double.valueOf(st.nextToken());
                x2 = Double.valueOf(st.nextToken());
                y2 = Double.valueOf(st.nextToken());
                z2 = Double.valueOf(st.nextToken());
                
                // putting outnodes
                if(searchP(x1,y1,z1)==null){
                    points.add(new Point(x1,y1,z1));
                    points.get(points.size()-1).outnodes = new ArrayList<Point>();
                    points.get(points.size()-1).outnodes.add()
                }
                if(outnodesMap.get(point1)==null){
                   outnodesMap.put(point1,new ArrayList<double[]>());
                   outnodesMap.get(point1).add(new double[]{x2,y2,z2});
                   
                   
                   double[] tm = new double[]{x2,y2,z2};
                   //outnodesMap.put(new double[]{x2,y2,z2},new ArrayList<double[]>());
                   //if(outnodesMap.get(new double[]{x2,y2,z2})==null)
                   //    System.out.println("nic tam neni");
                   outnodesMap.put(tm,new ArrayList<double[]>());
                   if(outnodesMap.get(tm)==null)
                       System.out.println("nic tam neni");   
                   else{
                       System.out.println("neco tam je");
                   }
                   outnodesMap.get(new double[]{x2,y2,z2}).add(new double[]{point1[0],point1[1],point1[2]});                    
                    
                }
                else{
                    outnodesMap.get(point1).add(new double[]{x2,y2,z2});
                }
                
                // price and visited false
                tmp6 = new double[]{point1[0],point1[1],point1[2],x2,y2,z2};
                price.put(tmp6, getPrice(point1,x2,y2,z2));
                //System.out.println(""+price.get(point1));
                visited.put(point1, false);
                visited.put(new double[]{x2,y2,z2}, false);
            }
                
            // we have edges, lets compute
            findWay();
            System.out.printf("%.4f",minPath);
           
           
        }
        
    }
    
}

    class Point{
        public double x,y,z,reachPrice;
        public ArrayList<Point> outnodes = new ArrayList<Point>();
        public boolean visited = false;
        
        public Point(double x, double y, double z){
            this.x=x;
            this.y=y;
            this.z=z;
        }
    }